.deploy: &deploy
  stage: deploy
  only:
    - tags
  dependencies:
    - package:tag
  script:
    - cat $KUBECONFIG > /root/.kube/config
    - helm template ${CI_PROJECT_NAME}-$CI_COMMIT_TAG.tgz | kubectl apply -n ${CI_JOB_NAME##*:} -f -

image: docker.rmb938.me/kubernetes/helm:latest

before_script:
  - kubectl version -c
  - helm version -c

stages:
  - lint
  - package
  - deploy

lint:
  stage: lint
  only:
   - pushes
  except:
    - tags
  script:
    - helm lint

package:push:
  stage: package
  only:
    - pushes
  except:
    - tags
  script:
    - export VERSION=$(git describe 2>/dev/null || echo -n "0.1.0-${CI_COMMIT_SHA:0:8}")
    - helm package --version $VERSION .

package:tag:
  stage: package
  only:
    - tags
  script:
    - helm package --version $CI_COMMIT_TAG .
  artifacts:
    expire_in: 1 month
    paths:
      - "*.tgz"

deploy:kube0:ingress:
  environment:
    name: kube0
  <<: *deploy

deploy:kube0:prometheus:
  environment:
    name: kube0
  <<: *deploy

deploy:kube0:sandwich:
  environment:
    name: kube0
  <<: *deploy

deploy:kube0:vault:
  environment:
    name: kube0
  <<: *deploy
